<template>
  <q-dialog ref="dialog" @hide="$emit('hide')">
    <q-card class="q-dialog-plugin" style="width: 500px; max-width: 85vw;">
      <ValidationObserver v-slot="{ handleSubmit }">
        <q-form ref="FormSubmit" @submit="handleSubmit(submit)">
          <q-card-section
        class="row bg-white q-pt-sm q-pb-none q-mb-none q-card--bordered text-primary"
        style="height: 50px">
        <div class="col-xs-6 text-weight-bolder  q-pt-sm">Changement de mot de passe</div>

        <div class="col-xs-6">
          <q-btn @click="onCancelClick" icon="la la-times"
                 outline class="text-red float-right on-right" flat/>
        </div>
      </q-card-section>

      <q-card-section class="row q-pa-md q-mt-md scroll" style="max-height: 70vh">
        <div class="col-12">
          <MField
            label="Mot de passe actuel"
            :main-design="'outlined'"
            validation-rules="required"
            orientation="vertical"
            :type-input="showOldPassword ? 'text' : 'password'"
            v-model="form.oldPassword"
            @m-keyup-enter="submit"
          >
            <template v-slot:mAppend>
              <q-icon
                :name="showOldPassword ? 'la la-eye' : 'la la-eye-slash'"
                class="cursor-pointer"
                color="blue-grey-3"
                @click="showOldPassword = !showOldPassword"
              />
            </template>
          </MField>
        </div>
        <div class="col-12">
          <MField
            validation-id="confirmation"
            label="Nouveau mot de passe"
            :main-design="'outlined'"
            validation-rules="required"
            orientation="vertical"
            :type-input="showNewPassword ? 'text' : 'password'"
            v-model="form.newPassword"
            @m-keyup-enter="submit"
          >
            <template v-slot:mAppend>
              <q-icon
                :name="showNewPassword ? 'la la-eye' : 'la la-eye-slash'"
                class="cursor-pointer"
                color="blue-grey-3"
                @click="showNewPassword = !showNewPassword"
              />
            </template>
          </MField>
        </div>
        <div class="col-12">
          <MField
            label="Confirmation"
            :main-design="'outlined'"
            validation-rules="required|confirmed:confirmation"
            orientation="vertical"
            :type-input="showNewPassword ? 'text' : 'password'"
            v-model="form.passwordConfirmation"
            @m-keyup-enter="submit"
          >
            <template v-slot:mAppend>
              <q-icon
                :name="showNewPassword ? 'la la-eye' : 'la la-eye-slash'"
                class="cursor-pointer"
                color="blue-grey-3"
                @click="showNewPassword = !showNewPassword"
              />
            </template>
          </MField>
        </div>
      </q-card-section>

      <q-card-actions align="right" class=" text-primary">
        <q-btn
          color="primary" dense outline stretch
          label="Enrégistrer" text-color="primary"
          @click="onOKClick"/>
      </q-card-actions>
        </q-form>
      </ValidationObserver>
    </q-card>
  </q-dialog>
</template>

<script>
  import {mapActions, mapState} from 'vuex'
  import MSelect from "components/forms/MSelect";
  import MField from "components/forms/MField";
  import {required} from 'vee-validate/dist/rules';
  import {ValidationObserver} from 'vee-validate';
  // import accesscontrol from "../../mixins/accesscontrol";

  export default {
    name: 'PasswordChangeDialog.vue',
    components: {MField, MSelect, ValidationObserver},
    props: {
      title: {
        type: String,
        default: 'Changement de mot de passe'
      },
      state: {
        type: String,
        validator:  (value) => (['view', 'create', 'update'].indexOf(value) !== -1),
      },
      model: {
        type: Object,
        default: null
      },
    },

    data() {
      return {
        showNewPassword: false,
        showOldPassword: false,
        loading: false,
        form: {
          newPassword: null,
          oldPassword: null,
          passwordConfirmation: null,

        },
      }
    },

    methods: {
      show() {
        this.$refs.dialog.show()
      },
      hide() {
        this.$refs.dialog.hide()
      },
      onDialogHide() {
        this.$emit('hide')
      },
      async onOKClick() {
        try {
          this.submit()
        } catch (e) {
          console.error("err", e)
        }
      },
      onCancelClick() {
        this.hide()
      },

      async submit() {
        await this.$store.dispatch('auth/changePassword', this.form).then( (response) => {
          this.Motify('success', 'Le mot de passe a été changé')
          this.$emit('ok', response)
          this.hide()
          this.disconnectUser()
        }).catch(err => {
          this.Motify("error", err.message)
          console.error(err);
        })
      },

      disconnectUser() {
        this.$store.dispatch('auth/logout')
          .then(() => {
            this.$router.push('/login')
          })
      },
    },

  }
</script>
